export default {

    data() {

        return {

        }
    },

    props: {
        submission: {
            type: Object
        }
    },

    computed: {
        fields() {
            return Object.keys(this.submission.data);
        },

        attachments() {

            if (Array.isArray(this.submission.attachments) && !this.submission.attachments.length) {
                return null;
            }

            return this.submission.attachments || [];
        }
    },

    template: /*html*/`
        <div class="app-offcanvas-container">
            <div class="kiss-padding kiss-flex kiss-flex-middle">
                <div class="kiss-margin-small-right">
                    <kiss-svg :src="$base('inbox:assets/icons/submissions.svg')" width="35" height="35"><canvas width="35" height="35"></canvas></kiss-svg>
                </div>
                <div>
                    <strong>{{ t('Submission') }}</strong>
                    <div class="kiss-size-small kiss-text-monospace kiss-color-muted">
                        {{ (new Date(submission._created * 1000).toLocaleString())  }}
                    </div>
                </div>
            </div>
            <div class="app-offcanvas-content kiss-padding kiss-bgcolor-contrast">

                <kiss-card class="kiss-padding-small kiss-margin-small" v-for="field in fields" theme="contrast bordered">
                    <div class="kiss-text-caption kiss-text-bold">{{ field }}</div>
                    <div class="kiss-margin-xsmall kiss-color-muted">{{ submission.data[field] || 'n/a' }}</div>
                </kiss-card>

                <div class="kiss-margin-top" v-if="attachments">

                    <div class="kiss-margin-small kiss-text-bold kiss-text-caption kiss-color-muted">{{ t('Attachments') }}</div>

                    <kiss-card v-for="files,field in attachments">

                        <div class="kiss-text-caption">{{field}}</div>

                        <div class="kiss-margin-xsmall" v-for="file in files">
                            <a class="kiss-flex kiss-flex-middle kiss-text-monospace" :href="$base('#uploads:'+file.file)" target="_blank" rel="noopener" download>
                                <icon class="kiss-margin-small-right">attachment</icon>
                                <span class="kiss-size-small">{{ file.name}}</span>
                            </a>
                        </div>
                    </kiss-card>

                </div>

            </div>
            <div class="kiss-padding">
                <button class="kiss-button kiss-width-1-1" kiss-offcanvas-close>{{ t('Close') }}</button>
            </div>
        </div>
    `
}
