export default {

    data() {
        return {
            data: null
        }
    },

    props: {
        menu: {
            type: String,
            default: null
        }
    },

    mounted() {
        this.load();
    },

    methods: {
        load() {

            this.$request(`/pages/menus/menu/${this.menu}/true`).then((data) => {
                this.data = data;
            }).catch((err) => {
                console.error(err);
            });
        }
    },

    template: /*html*/`
        <kiss-card>
            <app-loader size="small" mode="dots" v-if="!data"></app-loader>
            <div class="kiss-size-small kiss-flex kiss-flex-middle" v-if="data">
                <kiss-svg class="kiss-margin-small-right" :src="$base('pages:assets/icons/nav.svg')" width="20" height="20"><canvas width="20" height="20"></canvas></kiss-svg>
                {{ data.menu.label || data.menu.name  }}
            </div>
        </kiss-card>
    `
}
